###################################################
### chunk number 1: 
###################################################
#line 55 "d:/Rcompile/CRANpkg/local/2.12/cts/inst/doc/kf.Rnw"
options(prompt = "R> ", continue = "+  ", width = 70, useFancyQuotes = FALSE)


###################################################
### chunk number 2:  eval=FALSE
###################################################
## #line 58 "d:/Rcompile/CRANpkg/local/2.12/cts/inst/doc/kf.Rnw"
## install.packages("cts")


###################################################
### chunk number 3:  eval=FALSE
###################################################
## #line 62 "d:/Rcompile/CRANpkg/local/2.12/cts/inst/doc/kf.Rnw"
## library("cts")
## vignette("kf",package = "cts")


###################################################
### chunk number 4:  eval=FALSE
###################################################
## #line 67 "d:/Rcompile/CRANpkg/local/2.12/cts/inst/doc/kf.Rnw"
## edit(vignette("kf",package = "cts"))


###################################################
### chunk number 5: 
###################################################
#line 77 "d:/Rcompile/CRANpkg/local/2.12/cts/inst/doc/kf.Rnw"
#164 measurements of relative abundance of an oxygen isotope in an ocean core. These are unequally spaced time points with an average of separation of 2000 years. Unequally spaced tick marks indicate the corresponding irregularly sampled time.
library("cts")
data("V22174")


###################################################
### chunk number 6: 
###################################################
#line 86 "d:/Rcompile/CRANpkg/local/2.12/cts/inst/doc/kf.Rnw"
plot(V22174,type="l",xlab="Time in kiloyears", ylab="")
rug(V22174[,1], col="red")


###################################################
### chunk number 7: 
###################################################
#line 93 "d:/Rcompile/CRANpkg/local/2.12/cts/inst/doc/kf.Rnw"
#Time to finish the modeling
time <- system.time(V22174.car14 <- car(V22174,scale=0.2,order=14))[1]


###################################################
### chunk number 8: 
###################################################
#line 99 "d:/Rcompile/CRANpkg/local/2.12/cts/inst/doc/kf.Rnw"
#We first fit a model of order 14 to the data, following \citet{Belc:Hamp:Tunn:1994}. The scale parameter is chosen to be 0.2 as well. The estimation algorithm converges rather quickly as demonstrated in the following printout, which shows the sum of squares and the value of $\phi_{14}$ at each iteration. 
V22174.car14 <- car(V22174,scale=0.2,order=14)
tab1 <- cbind(V22174.car14$tnit, V22174.car14$ss, V22174.car14$bit[,14])
colnames(tab1) <- c("Iteration","Sum of Squares","phi_14")


###################################################
### chunk number 9: 
###################################################
#line 106 "d:/Rcompile/CRANpkg/local/2.12/cts/inst/doc/kf.Rnw"
print(as.data.frame(round(tab1,5)),row.names=FALSE, print.gap=8)


###################################################
### chunk number 10: 
###################################################
#line 111 "d:/Rcompile/CRANpkg/local/2.12/cts/inst/doc/kf.Rnw"
#A model selection is conducted with \code{AIC} which generates exactly the same results as Table 2 of \citet{Belc:Hamp:Tunn:1994}. Consequently, a model of order 7 is suggested.
AIC(V22174.car14)


###################################################
### chunk number 11: 
###################################################
#line 115 "d:/Rcompile/CRANpkg/local/2.12/cts/inst/doc/kf.Rnw"
V22174.car7 <- car(V22174,scale=0.2,order=7)
summary(V22174.car7)


###################################################
### chunk number 12: 
###################################################
#line 123 "d:/Rcompile/CRANpkg/local/2.12/cts/inst/doc/kf.Rnw"
#The estimated spectra for both models of order 14 and 7 are displayed on logarithmic (base 10) scale.
par(mfrow=c(2,1))
spectrum(V22174.car14)
spectrum(V22174.car7)


###################################################
### chunk number 13: 
###################################################
#line 145 "d:/Rcompile/CRANpkg/local/2.12/cts/inst/doc/kf.Rnw"
#To check model assumptions
tsdiag(V22174.car7)


###################################################
### chunk number 14: 
###################################################
#line 156 "d:/Rcompile/CRANpkg/local/2.12/cts/inst/doc/kf.Rnw"
#209 measurements of the lung function of an asthma patient. The time series is measured mostly at 2 hour time intervals but with irregular gaps, as demonstrated by the unequal space of tick marks.
data("asth")


###################################################
### chunk number 15:  eval=FALSE
###################################################
## #line 160 "d:/Rcompile/CRANpkg/local/2.12/cts/inst/doc/kf.Rnw"
## plot(asth,type="l",xlab="Time in hours", ylab="")
## rug(asth[,1], col="red")


###################################################
### chunk number 16: 
###################################################
#line 167 "d:/Rcompile/CRANpkg/local/2.12/cts/inst/doc/kf.Rnw"
plot(asth,type="l",xlab="Time in hours", ylab="")
rug(asth[,1], col="red")


###################################################
### chunk number 17: 
###################################################
#line 175 "d:/Rcompile/CRANpkg/local/2.12/cts/inst/doc/kf.Rnw"
#a scale parameter 0.25 is chosen and a model of order 4 is fitted to the data.
asth.car4 <- car(asth,scale=0.25,order=4, ctrl=car_control(n.ahead=10))
summary(asth.car4)


###################################################
### chunk number 18: 
###################################################
#line 185 "d:/Rcompile/CRANpkg/local/2.12/cts/inst/doc/kf.Rnw"
#The log-spectrum (base 10) of the fitted model is shown in Figure~\ref{fig:asth2}. The spectral peak indicates a strong diurnal cycle in the data, along with a low frequency.
spectrum(asth.car4)


###################################################
### chunk number 19: 
###################################################
#line 194 "d:/Rcompile/CRANpkg/local/2.12/cts/inst/doc/kf.Rnw"
#With function \code{factab}, the model has one diurnal frequency 0.041, a low frequency component and the other close to white noise component.
factab(asth.car4)


###################################################
### chunk number 20: 
###################################################
#line 201 "d:/Rcompile/CRANpkg/local/2.12/cts/inst/doc/kf.Rnw"
#We thus can decompose the original time series into three components via the Kalman smoother
asth.kalsmo <- kalsmo(asth.car4)
par(mfrow=c(3,1))
kalsmoComp(asth.kalsmo,comp=1, xlab="Time in hours")
kalsmoComp(asth.kalsmo,comp=c(2,3), xlab="Time in hours")
kalsmoComp(asth.kalsmo,comp=4,xlab="Time in hours")


###################################################
### chunk number 21: 
###################################################
#line 216 "d:/Rcompile/CRANpkg/local/2.12/cts/inst/doc/kf.Rnw"
#We predict the last 10 steps past the end of time series
predict(asth.car4, xlab="Time in hours")


